<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIGL: src/standard/GraphGen/tiglGraphGenConstructGraphRmat.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIGL
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_512e97a87e29490d503e7e4403f25482.html">standard</a></li><li class="navelem"><a class="el" href="dir_1cf3643344231f8e6485fa845aa22d81.html">GraphGen</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglGraphGenConstructGraphRmat.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglGraphGenConstructGraphRmat_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#ifndef CONSTRUCT_GRAPH_RMAT_HPP</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#define CONSTRUCT_GRAPH_RMAT_HPP</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;math.h&gt;</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">//#include &lt;stdlib.h&gt;</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &quot;tools.hpp&quot;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment">//using namespace std;</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#define     MAX_PROB_COUNT      1000</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#define     MAX_STEPS           30 // equivalent to 1B  edges</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#define     SMOOTH_SCALE        0.02</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> VertexClass&gt;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keywordtype">void</span> tiglGenerationConstructGraphRmat(<span class="keyword">typename</span> VertexClass::ID_TYPE numVertices, <span class="keywordtype">long</span> meanNumEdges, </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;                            vector&lt;VertexClass&gt; &amp; verticesList, </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;                            <span class="keywordtype">double</span> a = 0.25, <span class="keywordtype">double</span> b = 0.25, <span class="keywordtype">double</span> c = 0.25, <span class="keywordtype">double</span> d = 0.25, </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;                            <span class="keywordtype">bool</span> isDirected = <span class="keyword">true</span>, </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;                            <span class="keyword">typename</span> VertexClass::ID_TYPE startID = 0)</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> * Inputs:</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> * numVertices: total number of vertices in the output graph</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="comment"> * meanNumEdges: the mean of the number of output edges per vertex</span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment"> * isDirected:  a flag which is set to &quot;true&quot; if the graph is directed, otherwise it is set to &quot;false&quot;</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"> * verticesList: output vector of all the vertices in the graph</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"> *  a, b, c, d: probability parameters that governs the graph generation algorithm</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"> *  startID: starting value of the key of the graph vertices</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;{</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> VertexClass::EDGE_TYPE EDGE_TYPE;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> VertexClass::ID_TYPE ID_TYPE;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keywordtype">double</span> bufProb[MAX_PROB_COUNT];</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keywordtype">double</span> modProb[MAX_STEPS*4];</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> numSteps = (<span class="keywordtype">unsigned</span> long)ceil(log((<span class="keywordtype">double</span>)numVertices)/log(2.0));</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    ID_TYPE N = ((ID_TYPE)1)&lt;&lt; numSteps;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    ID_TYPE targetTotalEdges = meanNumEdges*numVertices;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="comment">//ID_TYPE totalEdges = ceil(targetTotalEdges*ratio*ratio);</span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keywordflow">if</span> (isDirected == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    { <span class="comment">// if undirected graph, each input edge is also considered an output edge</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        targetTotalEdges /= 2;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    }</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordflow">if</span>(verticesList.empty() == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    {</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        cout &lt;&lt; <span class="stringliteral">&quot;Warning ! input vertices list is not empty&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    }</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="keywordtype">double</span> prob[3]; <span class="comment">// original abcd values</span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="comment">//double currProb[3]; // values that are perturbed at each iteration</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keywordtype">double</span> sumABCD = a+b+c+d;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    prob[0] = a/sumABCD;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    prob[1] = prob[0]+b/sumABCD;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    prob[2] = prob[1]+c/sumABCD;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="comment">//prob[3] = prob[2]+d;</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="comment">// allocating enough memory to the vertices list</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="comment">// and assigning default keys to them</span></div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keywordflow">for</span> (ID_TYPE loopCount = 0; loopCount &lt; numVertices; loopCount++)</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    {</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        VertexClass tmpClass(loopCount+startID); <span class="comment">// assigning loop count as vertex id</span></div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        verticesList.push_back(tmpClass);</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    }</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    ID_TYPE edgeCount = 0;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="comment">// generating the prabability in bulks to increase the efficiency</span></div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    ID_TYPE probCount = 0;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    tiglUtilsGenUrandom(bufProb, MAX_PROB_COUNT);</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="keywordflow">while</span>(edgeCount &lt; targetTotalEdges)<span class="comment">//for(loopCount = 0; loopCount &lt; totalEdges; loopCount++)</span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    {</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        ID_TYPE src = 0;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        ID_TYPE target  = 0;</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        ID_TYPE shift = N/2;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <span class="keywordflow">if</span>(probCount &gt;= MAX_PROB_COUNT-numSteps)</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        {<span class="comment">// if near end of probability buffer refill it</span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;            tiglUtilsGenUrandom(bufProb, MAX_PROB_COUNT);</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;            probCount = 0;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        }</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        tiglUtilsGenUrandom(modProb, numSteps*4);</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> j = 0 ;j&lt; numSteps*4;j++)</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;            modProb[j] *= SMOOTH_SCALE;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        <span class="comment">// loop for computing the x-y position of the edge in the incidence matrix</span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> step = 0 ; step &lt; numSteps ; step++)</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        {</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;            <span class="keywordtype">double</span> r = bufProb[probCount++];</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;            <span class="keywordtype">unsigned</span> ind = step &lt;&lt; 2;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;            <span class="keywordflow">if</span>((r &gt;= prob[0]+modProb[ind]) &amp;&amp; (r &lt; prob[1]+modProb[ind+1]) ) <span class="comment">// second quadrant</span></div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;                target += shift;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;            <span class="keywordflow">else</span> <span class="keywordflow">if</span>( (r &gt;= prob[1]+modProb[ind+1])  &amp;&amp; (r &lt; prob[2]+modProb[ind+2]) ) <span class="comment">// third quadrant</span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;                src += shift;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;            <span class="keywordflow">else</span> <span class="keywordflow">if</span> (r &gt;= prob[2]+modProb[ind+2]) <span class="comment">// fourth quadrant</span></div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;            {</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;                src += shift; target += shift;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;            }</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;            <span class="comment">// if r &lt; prob[0] -&gt; it falls in first quadrant and no action is needed</span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;            shift /= 2;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        }</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        <span class="comment">// mapping to new edge to both the vertex list and edge list</span></div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        <span class="keywordflow">if</span>(src &gt;= numVertices || target &gt;= numVertices)</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;            <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        <span class="comment">// if an edge already exists ignore this edge</span></div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        <span class="keywordflow">if</span>(verticesList[src].isConnected(target))</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;            <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        <span class="keywordflow">if</span>(isDirected == 0 &amp;&amp; target &gt; src) <span class="comment">// skipping the upper half of the adjacency matrix (because of the clip and flip that is used later)</span></div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;            <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        EDGE_TYPE newEdge(target);</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        <span class="comment">//edgesList.push_back(newEdge);</span></div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        <span class="comment">// now attaching this edge to the corresponding vertex</span></div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        verticesList[src].add_edge(newEdge);</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        <span class="keywordflow">if</span>(isDirected == 0)</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        {</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;            EDGE_TYPE newInEdge(src);</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;            verticesList[target].add_edge(newInEdge);</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        }</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        { <span class="comment">// adding to the input edges list</span></div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;            <span class="keywordflow">if</span>(verticesList[target].is_bivertex())</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;            {</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;                verticesList[target].add_in_edge(src);</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;            }</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        }</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        edgeCount ++;</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    } <span class="comment">// end of the edge loop</span></div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;}</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> GraphClass&gt;</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;<span class="keywordtype">void</span> tiglGenerationConstructGraphRmat(<span class="keyword">typename</span> GraphClass::ID_TYPE numVertices, <span class="keywordtype">long</span> meanNumEdges, </div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;                            GraphClass &amp; graph, </div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;                            <span class="keywordtype">double</span> a = 0.25, <span class="keywordtype">double</span> b = 0.25, <span class="keywordtype">double</span> c = 0.25, <span class="keywordtype">double</span> d = 0.25)</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;<span class="comment"> * Inputs:</span></div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;<span class="comment"> * numVertices: total number of vertices in the output graph</span></div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;<span class="comment"> * meanNumEdges: the mean of the number of output edges per vertex</span></div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;<span class="comment"> * isDirected:  a flag which is set to &quot;true&quot; if the graph is directed, otherwise it is set to &quot;false&quot;</span></div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;<span class="comment"> * verticesList: output vector of all the vertices in the graph</span></div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;<span class="comment"> *  a, b, c, d: probability parameters that governs the graph generation algorithm</span></div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;<span class="comment"> *  startID: starting value of the key of the graph vertices</span></div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;{</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> GraphClass::EDGE_TYPE EDGE_TYPE;</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> GraphClass::ID_TYPE ID_TYPE;</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> GraphClass::VERTEX_TYPE VERTEX_TYPE;</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;    <span class="keywordtype">double</span> bufProb[MAX_PROB_COUNT];</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> numSteps = (<span class="keywordtype">unsigned</span> long)ceil(log((<span class="keywordtype">double</span>)numVertices)/log(2.0));</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;    ID_TYPE N = ((ID_TYPE)1)&lt;&lt; numSteps;</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    ID_TYPE targetTotalEdges = meanNumEdges*numVertices;</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    <span class="keywordflow">if</span>(graph.get_num_vertices() &lt; numVertices &amp;&amp; graph.isDirected() == <span class="keyword">true</span>)</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    {</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        graph.createVerticesList(numVertices);</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    }</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;<span class="comment">//  if (graph.isDirected() == false)</span></div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;<span class="comment">//  { // if undirected graph, each input edge is also considered an output edge</span></div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;<span class="comment">//      targetTotalEdges /= 2;</span></div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;<span class="comment">//  }</span></div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;    <span class="keywordtype">double</span> prob[3];</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;    <span class="keywordtype">double</span> sumABCD = a+b+c+d;</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    prob[0] = a/sumABCD;</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;    prob[1] = prob[0]+b/sumABCD;</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;    prob[2] = prob[1]+c/sumABCD;</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    ID_TYPE edgeCount = 0;</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    <span class="comment">// generating the prabability in bulks to increase the efficiency</span></div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;    ID_TYPE probCount = 0;</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    tiglUtilsGenUrandom(bufProb, MAX_PROB_COUNT);</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;    <span class="keywordflow">while</span>(edgeCount &lt; targetTotalEdges)<span class="comment">//for(loopCount = 0; loopCount &lt; totalEdges; loopCount++)</span></div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    {</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        ID_TYPE src = 0;</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        ID_TYPE target  = 0;</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;        ID_TYPE shift = N/2;</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;        <span class="keywordflow">if</span>(probCount &gt;= MAX_PROB_COUNT-numSteps)</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;        {<span class="comment">// if near end of probability buffer refill it</span></div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;            tiglUtilsGenUrandom(bufProb, MAX_PROB_COUNT);</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;            probCount = 0;</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;        }</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;        <span class="comment">// loop for computing the x-y position of the edge in the incidence matrix</span></div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;        <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> step = 0 ; step &lt; numSteps ; step++)</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;        {</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;            <span class="keywordtype">double</span> r = bufProb[probCount++];</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;            <span class="keywordflow">if</span>(r &gt;= prob[0] &amp;&amp; r &lt; prob[1]) <span class="comment">// second quadrant</span></div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;                target += shift;</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;            <span class="keywordflow">else</span> <span class="keywordflow">if</span>(r &gt;= prob[1] &amp;&amp; r &lt; prob[2]) <span class="comment">// third quadrant</span></div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;                src += shift;</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;            <span class="keywordflow">else</span> <span class="keywordflow">if</span> (r &gt;= prob[2]) <span class="comment">// fourth quadrant</span></div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;            {</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;                src += shift; target += shift;</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;            }</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;            <span class="comment">// if r &lt; prob[0] -&gt; it falls in first quadrant and no action is needed</span></div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;            shift /= 2;</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        }</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        <span class="comment">// mapping to new edge to both the vertex list and edge list</span></div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;        <span class="keywordflow">if</span>(src &gt;= numVertices || target &gt;= numVertices)</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;            <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;        <span class="comment">// if an edge already exists ignore this edge</span></div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;        <span class="keywordflow">if</span>(graph.isConnected(src, target))</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;            <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;        EDGE_TYPE newEdge(target);</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;        graph.addOutEdge(src, newEdge);</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        EDGE_TYPE newInEdge(src);</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        graph.addInEdge(target, newInEdge);</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;        edgeCount ++;</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;    } <span class="comment">// end of the edge loop</span></div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;}</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;</div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Oct 14 2014 14:29:26 for TIGL by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
